# -*- coding: utf-8 -*-

from twootr import web, render
from twootr.core import Core

class login(Core):
	def GET(self):
		self.epic_fail()
	
	def POST(self):
		inputs = web.input()
		if "nick" in inputs:
			user = self.get_user(inputs.nick)
			if user:
				return self.logged(inputs.nick)
			else:
				return self.epic_fail()
		else:
			return self.epic_fail()

class logout(Core):
	def GET(self):
		self.logout()

class register(Core):
	def GET(self):
		user = self.get_logged_user()
		if user:
			return self.go_home()
		else:
			return self.base(render.register( \
				{"nick":"Your Nickname", "jid":"your.jid@jabberserver.org"}, \
				{}, \
				{"nick":"default","jid":"default"}))
	
	def POST(self):
		inputs = web.input()
		errors = {}
		if not "nick" in inputs or not len(inputs.nick):
			errors["nick"] = "The nick name is a required field."
		#TODO: validating the format, the availability, etc...	
		
		if not "jid" in inputs or not len(inputs.jid):
			errors["jid"] = "The Jabber/GTalk ID is a required field."
		#TODO: validating the format, the availability, etc...
		
		if not errors:
			try:
				self.add_user(inputs.nick, inputs.jid)
				self.send_adduser(inputs.jid.decode("utf-8"))
				return self.logged(inputs.nick)
			
			except StandardError, e:
				if str(e).find("nick") > -1:
					errors["nick"] = "This nick name is alrady in use."
				
				if str(e).find("jid") > -1:
					errors["jid"] = "This Jabber/GTalk ID is alrady in use."
				
		return self.base(render.register(inputs, errors, {"nick":"","jid":""}))

class friendships(Core):
	_actions = ("subscribe", "unsubscribe")
	
	def GET(self, followee_nick, action):
		me = self.get_logged_user()
		if me:
			user = self.get_user(followee_nick)
			if user:
				web.debug(me)
				web.debug(user)
				friendship = self.is_friend_with(me, user)
				web.debug(friendship)
				if action in self._actions:
					web.debug(action)
					if action == "subscribe" and not friendship:
						web.debug("subscribe")
						self.add_friendship(me, user)
					elif action == "unsubscribe" and friendship:
						web.debug("unsubscribe")
						self.del_friendship(me, user)
					return self.redirect("/%s/" % followee_nick)
				else:
					return self.epic_fail()
			else:
				return self.epic_fail()
		else:
			return self.redirect("/register/")
